// Inicializace virtualniho predka
// Odstranenim zakomentovaneho useku inicializacni casti E 
// dosahneme, ze zdedena slozka A se bude inicializovat spravne

#include <iostream>
using namespace std;

struct A
{
	int a;
	A(int aa = 0)
		:a(aa)
	{}
	void vypis()
	{
		cout << "slozka a obsahuje " << a << endl;
	}
};

struct B : virtual A
{
	int b;
	B(int aa, int bb)
		: A(aa), b(bb)
	{}
};

struct C : virtual A
{
	int c;
	C(int aa, int cc)
		: A(aa), c(cc)
	{}
};

struct D : B, C
{
	int d;
	D(int aa, int bb, int cc, int dd)
		: /*A(aa),*/ B(aa, bb), C(aa, cc), d(dd)
	{}
};

int main()
{
	D d(1, 2, 3, 4);
	d.vypis();
}