#include <iostream>
using namespace std;

constexpr bool je_trojkova(char cislice)
{                                       // Kontrola spravnosti
	return (cislice >= '0') && (cislice <= '2');
}

template <unsigned hodnota>
constexpr unsigned trojkovy_literal()   // Zastavi rekurzi
{
	return hodnota;
}

template <unsigned hodnota, char cislice, char... zbytek>
constexpr unsigned trojkovy_literal()   // Vlastni zpracovani retezce
{
	static_assert(je_trojkova(cislice), "dovoleny jsou pouze cislice 0, 1 a 2");
	return trojkovy_literal<(3 * hodnota + cislice - '0'), zbytek...>();
}


template <char... znaky>
constexpr unsigned operator"" _t()
{
	return trojkovy_literal<0, znaky...>();
}

int main()
{
	//char A[32_t] = { 0 };    // Zpusobi chybu pri prekladu
	char A[22_t] = { 0 };
	cout << sizeof(A) << endl;
}
