// Nastroje pro testovani v dobe prekladu, zda jsou dva typu stejne

#include <iostream>
using namespace std;

template<class T, class U>
struct jsou_stejne
{
	static const bool hodnota = false;
};


template<class T>
struct jsou_stejne<T, T>
{
	static const bool hodnota = true;
};

template<class T>
struct je_void
{
	static const bool hodnota = jsou_stejne<T, void>::hodnota;
};

struct A {};
struct B {};
using C = A;

const int i = 8;
int j = 9;

template<typename T>
class pokus
{
	static_assert(!jsou_stejne<T, void>::hodnota, "chyba T je void");
	// ...
};


int main()
{
	pokus<void> pa;
	cout << boolalpha << jsou_stejne<decltype(i), decltype(j)>::hodnota << endl;
	cout << je_void<A>::hodnota << " " << je_void<void>::hodnota << endl;
}
