template<int n, typename T>
struct nasobitko
{
	static inline T skal_soucin(T* a, T* b)
	{
		return *a * *b + nasobitko<n - 1, T>::skal_soucin(a + 1, b + 1);
	}
};

template<typename T>
struct nasobitko<1, T>
{
	static inline T skal_soucin(T* a, T* b)
	{
		return *a * *b;
	}
};

template<int N, typename T>
inline T skalarni_soucin(T *a, T *b) 
{
	return nasobitko<N, T>::skal_soucin(a, b);
}


int main()
{
	double A[3] = { 1,2,3 };
	double B[3] = { 2,2,2 };
	double x = nasobitko<3, double>::skal_soucin(A, B);
	double y = skalarni_soucin<3>(A, B);
}