// Poad voln konstruktor a destruktor pi virtulnm ddn
#include <iostream>
using namespace std;

class A
{
public:
	A()
	{
		cout << "A";
	}
	A(int i)
	{
		cout << i;
	};
	~A()
	{
		cout << "A";
	}
};

class B : public A
{
public:
	B()
	{
		cout << "B";
	}
	B(int i) :A(i + 1)
	{
		cout << i;
	}
	~B()
	{
		cout << "B";
	}
};

class C : public B, public virtual A
{
public:
	C()
	{
		cout << "C";
	}
	C(int i) : A(i + 1)
	{
		cout << i;
	}
	~C()
	{
		cout << "C";
	}
};

class D : public B, public virtual A
{
public:
	D()
	{
		cout << "D";
	}
	~D()
	{
		cout << "D";
	}
};

class E : public C, virtual public D
{
public: 
	E()
	{
		cout << "E" << endl;
	}
	~E()
	{
		cout << "E";
	}
};

int main()
{
	E e;
	return 0;
}