#ifndef __MATICE_H__
#define __MATICE_H__
class matice 
{
	
	enum { poet = 10, };                // Velikost dku a sloupce matice
 	double(*p)[poet];                // Ukazatel na pole

	double &prvek(int i, int j) const;

public:
	
	matice(double d = 0.0);            // Konstruktor

	matice(const matice&);             // Koprovac konstruktor

	matice(matice&&);
	
	~matice();                         // Destruktor

	matice transpozice() const;        // Transposice matice

	matice& operator=(const matice&);

	matice& operator=(matice&&);

	friend matice operator-(const matice& m);

	matice operator+(const matice& m) const;

	matice operator*(const double d) const;

	double* operator[](int) const;

	double& operator ()(int, int);

	double operator ()(int, int) const;

	void vpis();

	friend matice operator*(const matice& m, const matice& n);

};

class auto_ptr_mat
{
	matice* pm;
	bool vlastnk;
public:
	auto_ptr_mat(matice*);
	auto_ptr_mat(auto_ptr_mat&);
	~auto_ptr_mat() { if (vlastnk) delete pm; }
	matice *operator->();
	auto_ptr_mat& operator=(auto_ptr_mat&);
};



inline matice operator*(double d, matice m)
{
	return m * d;
}
#endif