#include <iostream>
using namespace std;

constexpr bool je_trojkov(char slice)
{                                       // Kontrola sprvnosti
	return (slice >= '0') && (slice <= '2');
}

template <unsigned hodnota, char slice, char... zbytek>
constexpr unsigned trojkov_literl()   // Vlastn zpracovn etzce
{
	static_assert(je_trojkov(slice), "dovoleny jsou pouze slice 0, 1 a 2");
	return trojkov_literl<(3 * hodnota + slice - '0'), zbytek...>();
}

template <unsigned hodnota>
constexpr unsigned trojkov_literl()   // Zastav rekurzi
{
	return hodnota;
}

template <char... znaky>
constexpr unsigned operator"" _t()
{
	return trojkov_literl<0, znaky...>();
}

int main()
{
	//char A[32_t] = { 0 };    // Zpsob chybu pi pekladu
	char A[22_t] = { 0 };
	cout << sizeof(A) << endl;
}
