#include <iostream>
using namespace std;

template<int M, int N>
struct ack
{
	enum { vsledek = ack<M - 1, ack<M, N - 1>::vsledek>::vsledek };
};

template<int M>
struct ack<M, 0>
{
	enum { vsledek = ack<M - 1, 1>::vsledek };
};

template<int N>
struct  ack<0, N>
{
	enum { vsledek = N + 1 };
};

int ackermann(int m, int n)
{
	if (m == 0)
	{
		return n + 1;
	}
	else if (n == 0)
	{
		return ackermann(m - 1, 1);
	}
	else
	{
		return ackermann(m - 1, ackermann(m, n - 1));
	}
}


int main()
{
	int pole[ack<2, 2>::vsledek] = {};
	cout << ackermann(2, 2) << endl;
	cout << ack<2, 2>::vsledek << endl;
}