// Nstroje pro testovn v dob pekladu, zda jsou dva typu stejn

#include <iostream>
using namespace std;

template<class T, class U>
struct jsou_stejn
{
	static const bool hodnota = false;
};


template<class T>
struct jsou_stejn<T, T>
{
	static const bool hodnota = true;
};

template<class T>
struct je_void
{
	static const bool hodnota = jsou_stejn<T, void>::hodnota;
};

struct A {};
struct B {};
using C = A;

const int i = 8;
int j = 9;

template<typename T>
class pokus
{
	static_assert(!jsou_stejn<T, void>::hodnota, "chyba T je void");
	// ...
};


int main()
{
	pokus<void> pa;
	cout << boolalpha << jsou_stejn<decltype(i), decltype(j)>::hodnota << endl;
	cout << je_void<A>::hodnota << " " << je_void<void>::hodnota << endl;
}
