#include <iostream>
using namespace std;

// ablona . 1 (primrn ablona)
template <typename T, int N>
class vektor {
	T p[N];
public:
	vektor(T t = 0)
	{
		for (int i = 0; i < N; i++)
		{
			p[i] = t;
		}
	}

	T& operator[](int i)
	{
		return p[i];
	}
	// ... a dal metody ...
};

template <typename T, int N>            // . 2 (prvn specializace)
class vektor<T*, N> {
	T *p[N];
public:
	vektor(T t = 0)
	{
		for (int i = 0; i < N; i++)
		{
			p[i] = new T(t);
		}
	}

	T& operator[](int i)
	{
		return *p[i];
	}
};

template <typename T>                   // . 3 (dal specializace)
class vektor<T*, 2>
{
	// ... sloky a metody ...
};

template<>
vektor<int, 2>::vektor(int i)           // . 4 (jen konstruktor)
{
	cout << "Pozor: <int, 2>" << endl;
	// ... inicializace vektoru ...
}


int main()
{
	vektor<int, 10> vi;                     // Pouije se ablona . 1
	vektor<long*, 10> vlp;                  // ablona . 2, T == long
	vektor<double*, 2> vdp;                 // ablona . 3, T == double
	vektor<long*, 10> vld;
	vektor<int, 2> vi2;
}
