#include <iostream>
using namespace std;


template<typename HLAVA, typename...OHON>
class entice
	: public entice<OHON...>
{
	typedef entice<OHON...> Ohon;
public:
	entice() {};
	entice(HLAVA hlava, OHON ... ohon)
		: m_hlava(hlava), Ohon(ohon...) {}
	auto &get()
	{
		return m_hlava;
	}
	entice<OHON...>* baze() { return static_cast<Ohon*>(this); }
protected:
	HLAVA m_hlava;
};

template<typename HLAVA>
class entice<HLAVA>
{
public:
	entice() {}
	entice(HLAVA hlava)
		:m_hlava(hlava) {}

	auto &get() 
	{ 
		return m_hlava;
	}
	entice *baze() { return this; }
protected:
	HLAVA m_hlava;
};

template<int N, typename T1, typename...dalsi>
struct vyber
{
	typedef typename vyber<N - 1, dalsi...>::typ typ;
};

template<typename T1, typename...dalsi>
struct vyber<0, T1, dalsi...>
{
	typedef T1 typ;
};


vyber<2, int, long, double>::typ x = 0;


template<typename VYSLEDEK, int N>
struct najdi
{
	template<typename T>
	static VYSLEDEK& get(T& t)
	{
		return najdi<VYSLEDEK, N - 1>::get(*t.baze());
	}
};

template<typename VYSLEDEK>
struct najdi<VYSLEDEK, 0>
{
	template<typename T>
	static VYSLEDEK& get(T& t)
	{
		return t.get();
	}
};

template<int N, typename...T>
typename vyber<N, T...>::typ & get(entice<T...>& t)
{
	return najdi<vyber<N, T...>::typ, N>::get(t);
}

int main()
{
	x = 5;
	entice<double, int, long> en(6.0, 8, 9l);
	//ggg(en);
	auto yyy = get<2>(en);
	get<1>(en) = 333;
	cout << en.get() << endl;
	cout <<  en.baze()->get() << endl;
	cout << en.baze()->baze()->get() << endl;
}