template<typename T>
struct typ2typ
{
	typedef T typ;
};

template<int N>
struct int2typ
{
	enum { hodnota = N };
};

template<bool podminka, typename T1, typename T2>
struct if_then_else;

template<typename T1, typename T2>
struct if_then_else<true, T1, T2>
{
	typedef T1 typ;
};

template<typename T1, typename T2>
struct if_then_else<false, T1, T2>
{
	typedef T2 typ;
};

const int N = 3;

template<int N>
struct faktorial
{
	static_assert(N >= 0, "faktorial zaporneho cisla neexistuje");
	enum{hodnota = N*faktorial<N-1>::hodnota};
};

template<>
struct faktorial<0>
{
	enum { hodnota = 1 };
};

constexpr int fakt(int n)
{
	return n == 0 ? 1 : n*fakt(n - 1);
}

int main()
{
	int A[faktorial<3>::hodnota];
	cout << faktorial<5>::hodnota << endl;
	if_then_else < (N>0), long, int >::typ y = 66;
	typ2typ<int>::typ x = int2typ<4>::hodnota;
}