
template <unsigned hodnota>                             
constexpr unsigned trojkovy_literal()
{
	return hodnota;
}

constexpr bool je_trojkova(char cislice)
{
	return (cislice >= '0') && (cislice <= '2');
}

template <unsigned hodnota, char cislice, char... zbytek>   
constexpr unsigned trojkovy_literal()
{ 
	static_assert(je_trojkova(cislice), "dovoleny jsou pouze cislice 0, 1 a 2");
	return trojkovy_literal<(3 * hodnota + cislice - '0'), zbytek...>(); // (C)
}

template <char... znaky>
constexpr unsigned operator"" _t()
{
	return trojkovy_literal<0, znaky...>();        // (A)
}