/*
* Uvodni priklad na strukturovane vyjimky
* Program skonci chybou, protoze pro i == 4
* vznikne vyjimka, kterou obsluha odmitne osetrit
* a jina tam neni
*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#define VYJIMKA_0 0 	/* Definujeme chybove kody */
#define VYJIMKA_1 1
#define VYJIMKA_2 2
#define VYJIMKA_3 3

int Filtr(EXCEPTION_POINTERS *ep) 			/* Filtrovaci funkce */
{
	if (ep->ExceptionRecord->ExceptionFlags
		== EXCEPTION_NONCONTINUABLE)
		return EXCEPTION_EXECUTE_HANDLER;
	else switch (ep->ExceptionRecord->ExceptionCode)
	{
	case VYJIMKA_0: 					/* pouzijeme kod chyby */
		return EXCEPTION_CONTINUE_EXECUTION;
	case VYJIMKA_1:
	case VYJIMKA_2:
		return EXCEPTION_EXECUTE_HANDLER;;
	case VYJIMKA_3:
	default:
		return EXCEPTION_CONTINUE_SEARCH;
	}
}

int main()
{
	system("CHCP 1250 > NUL");
	int i;
	for (i = 0; i < 5; i++)
		__try {
		printf("Je tu VYJIMKA_%i\n", i);
		RaiseException(i, 0, 0, 0); 									/* ! */
		printf("Jsme za vyjimkou\n");
	}
	__except (Filtr(GetExceptionInformation())) {
		printf("Osetrujeme vyjimku\n");
	}
	return 0;
}
