// Pouziti virtualnich metod ve tride pro vyjimky
// Stejne jako hierarchie.cpp, pouze pro kazdy typ vyjimky
// jina obsluha
// POZOR -- poradi obsluh musi byt takove, jako je
// zde uvedeno. Pri opacnem by prvni zachytila
// vsechny vyjimky


#include <iostream>
using namespace std;

// Hierarchie trid pro prenos informaci o vyjimce
class vyjimka1 
{
public:
	virtual void co_je() { cerr << "Vyjimka typu 1" << endl; }
};

class vyjimka2 : public vyjimka1 
{
public:
	virtual void co_je() { cerr << "Vyjimka typu 2" << endl; }
};

class vyjimka3 : public vyjimka2 
{
public:
	virtual void co_je() { cerr << "Vyjimka typu 3" << endl; }
};

int main()
{
	for (int i = 1; i < 4; i++)
		try
	{
		switch (i)
		{
		case 1: throw vyjimka1();	// Volani konstruktoru
		case 2: throw vyjimka2();
		case 3: throw vyjimka3();
		}
	}
	catch (vyjimka3 &v)
	{
		v.co_je();
		cout << "vyjimka 3" << endl; // Kazdy typ zpracujeme trochu jinak...
	}
	catch (vyjimka2 &v)
	{
		v.co_je();
		cout << "vyjimka 2" << endl;
	}
	catch (vyjimka1 &v)
	{
		v.co_je();
		cout << "vyjimka 1" << endl;
	}
	return 0;
}
