// Vyhledavani operatoru 
// Operator je deklarovan v kontextu operandu
// (Tj. ve stejnem jmennem prostoru jako jeho operand)
// a proto ho prekladac najde 


#include <iostream>

namespace alfa 
{
	class X {										// Operand i operator ve stejnem
		int a;										// kontextu
	public:
		X() :a(0) {}
		friend X& operator++(X& x);
	};

	X& operator++(X& x) { x.a++; return x; }
}

namespace beta 
{
	void f(alfa::X &aa) 
	{
		++aa; 	// Pouzijeme operator definovany v prostoru Alfa
	}			// tj. v kontextu operandu
}

void main()
{
	alfa::X x;
	beta::f(x);
}
