#include <iostream>

namespace detail
{
	struct dva { char c[2]; };
	template <class T> char test(int T::*);
	template <class T> dva test(...);
	template<class T, T v>
	struct konstanta {
		static constexpr T hodnota = v;
	};
}

template <class T>
struct je_to_tda : detail::konstanta<bool, sizeof(detail::test<T>(0)) == 1> {};


struct A {};
class B {};
union C {};
enum class D {};

int main()
{
	std::cout << std::boolalpha;
	std::cout << je_to_tda<A>::hodnota << std::endl;
	std::cout << je_to_tda<B>::hodnota << std::endl;
	std::cout << je_to_tda<C>::hodnota << std::endl;
	std::cout << je_to_tda<D>::hodnota << std::endl;
	std::cout << je_to_tda<long>::hodnota << std::endl;
}

