
template <unsigned hodnota>                             
constexpr unsigned trojkov_literl()
{
	return hodnota;
}

constexpr bool je_trojkov(char slice)
{
	return (slice >= '0') && (slice <= '2');
}

template <unsigned hodnota, char slice, char... zbytek>   
constexpr unsigned trojkov_literl()
{ 
	static_assert(je_trojkov(slice), "dovoleny jsou pouze slice 0, 1 a 2");
	return trojkov_literl<(3 * hodnota + slice - '0'), zbytek...>(); // (C)
}

template <char... znaky>
constexpr unsigned operator"" _t()
{
	return trojkov_literl<0, znaky...>();        // (A)
}