// Zkladn pouit vjimky
// vetn deklarace vlastn tdy vjimek

#include <iostream>
#include <stdlib.h>
#include "seznam.h"
#include "chyba_seznamu.h"


using namespace std;

void vypi(seznam &s)
{
	s.reset();
	if (!s.przdn())
	{
		do
		{
			cout << s.aktuln_hodnota() << endl;
		} while (s.dal());
	}
}

void pprava()
{
	cout << "pprava" << endl;
}

void zpracuj(T hodnota)
{
	cout << "zpracovn " << hodnota << endl;
}

void klid()
{
	cout << "klid" << endl;
}

void zvr()
{
	cout << "zvr" << endl;
}

void vyuit(seznam& s)
{
	try
	{
		pprava();
		zpracuj(s.aktuln_hodnota());
		klid();
	}

	catch (chyba_seznamu oor)
	{
		cout << oor.what() << endl;
	}
	catch (...)
	{
		cout << "Pozor - neznm vjimka!" << endl;
		terminate();                    // Ukonme program
	}
	zvr();
}

int main()
{
	system("CHCP 1250 > NUL");
	seznam s = { 6,7,8, };
	vyuit(s);
	cout << "----" << endl;
	s.vyprzdni();
	vyuit(s);
}

