// Vyhledvn opertor 
// Opertor je deklarovn v kontextu operandu
// (Tj. ve stejnm jmennm prostoru jako jeho operand)
// a proto ho peklada najde 


#include <iostream>

namespace alfa 
{
	class X {										// Operand i opertor ve stejnm
		int a;										// kontextu
	public:
		X() :a(0) {}
		friend X& operator++(X& x);
	};

	X& operator++(X& x) { x.a++; return x; }
}

namespace beta 
{
	void f(alfa::X &aa) 
	{
		++aa; 	// Pouijeme opertor definovan v prostoru Alfa
	}			// tj. v kontextu operandu
}

void main()
{
	alfa::X x;
	beta::f(x);
}
